<template>
  <div>
    <h2 id="page-heading" data-cy="MedicamentoHeading">
      <span v-text="$t('gatewayApp.pacientesMedicamento.home.title')" id="medicamento-heading">Medicamentos</span>
      <div class="d-flex justify-content-end">
        <button class="btn btn-info mr-2" v-on:click="handleSyncList" :disabled="isFetching">
          <font-awesome-icon icon="sync" :spin="isFetching"></font-awesome-icon>
          <span v-text="$t('gatewayApp.pacientesMedicamento.home.refreshListLabel')">Refresh List</span>
        </button>
        <router-link :to="{ name: 'MedicamentoCreate' }" custom v-slot="{ navigate }">
          <button
            @click="navigate"
            id="jh-create-entity"
            data-cy="entityCreateButton"
            class="btn btn-primary jh-create-entity create-medicamento"
          >
            <font-awesome-icon icon="plus"></font-awesome-icon>
            <span v-text="$t('gatewayApp.pacientesMedicamento.home.createLabel')"> Create a new Medicamento </span>
          </button>
        </router-link>
      </div>
    </h2>
    <br />
    <div class="alert alert-warning" v-if="!isFetching && medicamentos && medicamentos.length === 0">
      <span v-text="$t('gatewayApp.pacientesMedicamento.home.notFound')">No medicamentos found</span>
    </div>
    <div class="table-responsive" v-if="medicamentos && medicamentos.length > 0">
      <table class="table table-striped" aria-describedby="medicamentos">
        <thead>
          <tr>
            <th scope="row" v-on:click="changeOrder('id')">
              <span v-text="$t('global.field.id')">ID</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'id'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('nombre')">
              <span v-text="$t('gatewayApp.pacientesMedicamento.nombre')">Nombre</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'nombre'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('descripcion')">
              <span v-text="$t('gatewayApp.pacientesMedicamento.descripcion')">Descripcion</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'descripcion'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('fechaIngreso')">
              <span v-text="$t('gatewayApp.pacientesMedicamento.fechaIngreso')">Fecha Ingreso</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'fechaIngreso'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('presentacion')">
              <span v-text="$t('gatewayApp.pacientesMedicamento.presentacion')">Presentacion</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'presentacion'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('generico')">
              <span v-text="$t('gatewayApp.pacientesMedicamento.generico')">Generico</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'generico'"></jhi-sort-indicator>
            </th>
            <th scope="row"></th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="medicamento in medicamentos" :key="medicamento.id" data-cy="entityTable">
            <td>
              <router-link :to="{ name: 'MedicamentoView', params: { medicamentoId: medicamento.id } }">{{ medicamento.id }}</router-link>
            </td>
            <td>{{ medicamento.nombre }}</td>
            <td>{{ medicamento.descripcion }}</td>
            <td>{{ medicamento.fechaIngreso ? $d(Date.parse(medicamento.fechaIngreso), 'short') : '' }}</td>
            <td v-text="$t('gatewayApp.Presentacion.' + medicamento.presentacion)">{{ medicamento.presentacion }}</td>
            <td>{{ medicamento.generico }}</td>
            <td class="text-right">
              <div class="btn-group">
                <router-link :to="{ name: 'MedicamentoView', params: { medicamentoId: medicamento.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-info btn-sm details" data-cy="entityDetailsButton">
                    <font-awesome-icon icon="eye"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.view')">View</span>
                  </button>
                </router-link>
                <router-link :to="{ name: 'MedicamentoEdit', params: { medicamentoId: medicamento.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-primary btn-sm edit" data-cy="entityEditButton">
                    <font-awesome-icon icon="pencil-alt"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.edit')">Edit</span>
                  </button>
                </router-link>
                <b-button
                  v-on:click="prepareRemove(medicamento)"
                  variant="danger"
                  class="btn btn-sm"
                  data-cy="entityDeleteButton"
                  v-b-modal.removeEntity
                >
                  <font-awesome-icon icon="times"></font-awesome-icon>
                  <span class="d-none d-md-inline" v-text="$t('entity.action.delete')">Delete</span>
                </b-button>
              </div>
            </td>
          </tr>
        </tbody>
        <infinite-loading
          ref="infiniteLoading"
          v-if="totalItems > itemsPerPage"
          :identifier="infiniteId"
          slot="append"
          @infinite="loadMore"
          force-use-infinite-wrapper=".el-table__body-wrapper"
          :distance="20"
        >
        </infinite-loading>
      </table>
    </div>
    <b-modal ref="removeEntity" id="removeEntity">
      <span slot="modal-title"
        ><span
          id="gatewayApp.pacientesMedicamento.delete.question"
          data-cy="medicamentoDeleteDialogHeading"
          v-text="$t('entity.delete.title')"
          >Confirm delete operation</span
        ></span
      >
      <div class="modal-body">
        <p id="jhi-delete-medicamento-heading" v-text="$t('gatewayApp.pacientesMedicamento.delete.question', { id: removeId })">
          Are you sure you want to delete this Medicamento?
        </p>
      </div>
      <div slot="modal-footer">
        <button type="button" class="btn btn-secondary" v-text="$t('entity.action.cancel')" v-on:click="closeDialog()">Cancel</button>
        <button
          type="button"
          class="btn btn-primary"
          id="jhi-confirm-delete-medicamento"
          data-cy="entityConfirmDeleteButton"
          v-text="$t('entity.action.delete')"
          v-on:click="removeMedicamento()"
        >
          Delete
        </button>
      </div>
    </b-modal>
  </div>
</template>

<script lang="ts" src="./medicamento.component.ts"></script>
